extends CharacterBody3D

# The downward acceleration when in the air, in meters per second squared.
@export var fall_acceleration = 75

var speed = 10
var target_velocity = Vector3.ZERO
var direction_facing = Vector3.FORWARD * -1
var default_colour = Color( 0.0, 0.0, 1.0, 1 )
@export var player_colour = default_colour

func initialize( spawn_point ) :
	position = spawn_point.position
	position.y += 0.1
	var material = $Pivot/model/body.mesh.surface_get_material( 0 )
	if material :
		material.albedo_color = player_colour
	
	add_to_group( "players" )
   
func _ready( ) :
	print( "Player has joined the game" )

func _physics_process( delta ) :
	var direction = Vector3.ZERO
	# Movement input checking
	if Input.is_action_pressed( "move_right" ) :
		direction.x -= 1
	if Input.is_action_pressed( "move_left" ) :
		direction.x += 1
	if Input.is_action_pressed( "move_backward" ) :
		direction.z -= 1
	if Input.is_action_pressed( "move_forward" ) :
		direction.z += 1
	
	# Calculate ground Velocity
	target_velocity.x = direction.x * speed
	target_velocity.z = direction.z * speed
	
	# Vertical Velocity
	if not is_on_floor( ) :
		target_velocity.y = target_velocity.y - ( fall_acceleration * delta )
	
	if direction != Vector3.ZERO :
		direction = direction.normalized( )
		# Setting the basis property will affect the rotation of the node.
		$Pivot.basis = Basis.looking_at( direction * -1 )
		# Keep track of the direction we're facing, we need this for shooting
		direction_facing = direction
	
	# Moving the Character
	velocity = target_velocity
	move_and_slide( )
