extends CharacterBody3D

var resource_number = 0
var max_energy = 100.0
var energy = 1.0
var max_health = 10.0
var health = 1.0
var target_health = 1.0
var colour_increment = 0.01
var min_radius = 0.5
var min_height = 4.0
var newly_growing = false

# Functions
###############################################################################
func initialize( spawn_position, game_start, resource_num ) :
	resource_number = resource_num
	
	position = spawn_position
	
	target_health = 3 + randf( ) * ( max_health * 0.75 )
	if game_start :
		health = target_health
	else :
		health = 0.1
		newly_growing = true
		
	var material = $MeshInstance3D.mesh.surface_get_material( 0 )
	if material :
		var rand_grey = 0.2 + ( randf( ) * 0.3 )
		var rand_red = randf( ) * 0.5 + 0.25
		var rand_green = randf( ) * 0.5 + 0.25
		material.albedo_color = Color( rand_red, rand_green, 0, 1 ).lerp( Color( rand_grey, rand_grey, rand_grey,1 ), 0.25 )
		energy = max_energy * ( 0.5 + rand_grey )
		colour_increment = ( 1 - material.albedo_color.r ) / max_health
	
	translate_health_to_size( )
	
	add_to_group( "resource_source" )

func translate_health_to_size( ) :
	var minimum_height = min_height
	if newly_growing :
		minimum_height = health
		if minimum_height > min_height :
			newly_growing = false
	var health_pct = health / max_health
	var radius = min_radius + ( ( 2 * min_radius ) * ( health_pct ) )
	$MeshInstance3D.mesh.height = minimum_height + ( minimum_height * ( health_pct ) )
	$MeshInstance3D.mesh.radius = radius
	$CollisionShape3D.shape.radius = radius
	$NavigationObstacle3D.radius = radius * 1.25
